<?php
/***************************************************************************
 *   @brief WP-Sentinel - Wordpress Security System .                      *
 *   @author Simone Margaritelli (aka evilsocket) <evilsocket@gmail.com>   *
 *                       		                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

class WPS_Log {
	private function geoLocalizeAddress( $ip ){
		$xml = @file_get_contents("http://www.ipinfodb.com/ip_query2_country.php?ip=$ip&output=xml");
		/* fallback on backup server */
		if( !$xml ){
			$xml = @file_get_contents("http://backup.ipinfodb.com/ip_query2_country.php?ip=$ip&output=xml");
		}
	
		if( preg_match_all( "/<CountryCode>([^<]+)<\/CountryCode>/im", $xml, $m ) ){
			return strtolower($m[1][0]);
		}
	
		return "unknown";
	}
		
	public function log( $wpuser, $scope, $variable, $content, $message, $rule ){
		global $wpdb;
		
		$address  = wp_sentinel_get_address();
		$agent    = htmlentities($_SERVER['HTTP_USER_AGENT']);
		$location = $this->geoLocalizeAddress($address);
		$referer  = htmlentities($_SERVER['HTTP_REFERER']);
		$username = (isset($wpuser->user_level) ? htmlentities($wpuser->user_login) : "");
		
		$wpdb->query( $wpdb->prepare(
			"INSERT INTO ".$wpdb->prefix."wps_logs (timestamp,address,location,agent,referer,username,scope,variable,content,message,rule) VALUES ( ".
				" %d, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s ".
			" );", 
			time(), 
			$address, 
			$location, 
			$agent,
			$referer, 
			$username, 
			$scope, 
			htmlentities($variable), 
			htmlentities($content), 
			htmlentities($message), 
			htmlentities($rule) ) );
	}
}
	
?>