<?php
/***************************************************************************
 *   @brief WP-Sentinel - Wordpress Security System .                      *
 *   @author Simone Margaritelli (aka evilsocket) <evilsocket@gmail.com>   *
 *                       		                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

$wps_rules = array( 
	array( "label"   => "XSS", 
		   "type"    => "script or html injection",
	       "pattern" => "<[^>]*(script|object|iframe|applet|meta|style|form|img|onmouseover|body)*\"?[^>]*>",
		   /* allowed tags list, edit at your own risk */
		   "allowed" => array( "blockquote", "strong", "b", "i", "em", "a", "p", "br", "p" ) ),
		   
	array( "label"   => "RFI", 
		   "type"    => "remote file inclusion",
	       "pattern" => "^(http|https|ftp|webdav)[\s]*:[\s]*\/[\s]*\/[\s]*.*\/.*\?",
	       /* classifier for PHP shells, bot, etc */
	       "classifier" => "/.*<\s*\?\s*(php)?.+\??\s*>?.*/im" ),
		   
	array( "label"   => "LFI", 
		   "type"    => "local file inclusion",
	       "pattern" => "\.+\/+" ),
		   
	array( "label"   => "SQL", 
		   "type"    => "sql injection",
		   "pattern" => "(;)?[\s]*insert.+into.+value.+" ),
		   
	array( "label"   => "SQL", 
		   "type"    => "sql injection",
		   "pattern" => "(;)?[\s]*(drop,alter,create).+(index,table,database)" ),
		   
	array( "label"   => "SQL", 
		   "type"    => "sql injection",
		   "pattern" => "update.+set.*=" ),
		   
	array( "label"   => "SQL", 
		   "type"    => "sql injection",
		   "pattern" => "union.+(all)?.*select" )
);
	
?>