<?php
/***************************************************************************
 *   @brief WP-Sentinel - Wordpress Security System .                      *
 *   @author Simone Margaritelli (aka evilsocket) <evilsocket@gmail.com>   *
 *                       		                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
if( preg_match( "/settings\.php/", $_SERVER['PHP_SELF'] ) ){ die (); }  

/*
 * Little routine to get UTF-8 encoded data from layout files. 
 */
function file_get_contents_utf8($filename) { 
     return utf8_decode(file_get_contents($filename));
} 

/*
 * Generate admin panel entry tabs.
 */
function wp_sentinel_generate_tabs(){
	$tabs = array( 'daily'    => 'Daily Logs',
				   'full'     => 'Full History',
				   'layouts'  => 'Layouts', 
				   'settings' => 'Settings' );
					  
	$active  = isset($_GET['tab']) ? $_GET['tab'] : 'daily';
	$active  = in_array( $active, array_keys($tabs) ) ? $active : 'daily';
	
	echo '<div id="nav">
		  	<h2 class="themes-php" style="border-bottom: 1px solid #CCC; padding: 0px;">';
	foreach( $tabs as $key => $label ){
		echo '<a class="nav-tab '.($active == $key ? 'nav-tab-active' : '').'" href="?page=wp-sentinel&tab='.$key.'">'.$label.'</a>';
	}
	echo '  </h2>
		  </div>';
}
	
/*
 * Handle the daily report tab. 
 */
function wp_sentinel_handle_daily(){
	global $wpdb;

	/*
	 * Dirty trick to create tables from 1.0.5 in case of update.
	 */
	wp_sentinel_create_tables(false);
		
	/* first of all, do some writability checking */
	$checks = array( 'vectors', 'php/config.php', 'layouts' );
	foreach( $checks as $check ){
		$item = WPS_PATH.$check;
		if( !is_writable($item) ){
			echo "<div style='background-color: white; color: red; font-size: 13px; padding: 10px; border: 1px dotted gray;'><b>'$item'</b> is not writable!!!.</div><br>";
		}
	}
	
	if( isset($_GET['wipe']) ){
		if( $_GET['wipe'] == "daily" ){
			$wpdb->query( $wpdb->prepare( "DELETE FROM ".$wpdb->prefix."wps_logs WHERE timestamp >= %d;", time() - 86400 ) );
		}
		else if( $_GET['wipe'] == "full" ){
			$wpdb->query( $wpdb->prepare( "DELETE FROM ".$wpdb->prefix."wps_logs;" ) );
		}
	}
	else if( isset($_GET['delete']) && is_numeric($_GET['delete']) ){
		$wpdb->query( $wpdb->prepare( "DELETE FROM ".$wpdb->prefix."wps_logs WHERE id = %d;", $_GET['delete'] ) );
	}
	
	$logs   = $wpdb->get_results( $wpdb->prepare( "SELECT * FROM ".$wpdb->prefix."wps_logs WHERE timestamp >= %d ORDER BY id DESC;", time() - 86400 ) );
	$n_logs = count($logs);
?>
<div style="background-color: white; border: 1px dotted gray; padding: 10px;">
	<b>Download</b> : <a href='<?= get_bloginfo('wpurl'); ?>/wp-content/plugins/wp-sentinel/logdownload.php?action=daily'>daily</a> - <a href='<?= get_bloginfo('wpurl'); ?>/wp-content/plugins/wp-sentinel/logdownload.php?action=full'>full</a>
	<div style="float:right">
	<b>Wipe</b> : <a href='?page=wp-sentinel&tab=daily&wipe=daily'>daily</a> - <a href='?page=wp-sentinel&tab=daily&wipe=full'>full</a>
	</div>
</div>
<?php	
	if( $n_logs ){
?>
<br>
<table width="100%" cellpadding="0" cellspacing="1" style="background-color: white; border: 1px dotted gray; padding: 0;">
	<tr><td>
<b>Logged <?= $n_logs ;?> attack<?= ($n_logs == 1 ? '' : 's') ?> within last 24 hours.</b>
<br>
<br>
<table width="100%" cellpadding="0" cellspacing="1" style="background-color: white; border: 1px dotted gray; padding: 0;">
<tr>
	<td style="font-weight: bold; background-color: #CCC; padding:3px;" align='center'>Time</th>
	<td style="font-weight: bold; background-color: #CCC; padding:3px;" align='center'>Location</th>
	<td style="font-weight: bold; background-color: #CCC; padding:3px;" align='center'>Address</th>
	<td style="font-weight: bold; background-color: #CCC; padding:3px;" align='center'>Scope</th>
	<td style="font-weight: bold; background-color: #CCC; padding:3px;" align='center'>Variable</th>
	<td style="font-weight: bold; background-color: #CCC; padding:3px;" align='center'>Alarm</th>
	<td style="font-weight: bold; background-color: #CCC; padding:3px;" align='center'>Details</th>
	<td style="font-weight: bold; background-color: #CCC; padding:3px;" align='center'>Delete</th>
</tr>
<?php
		$i = 0;
		foreach( $logs as $log ){
			$id		  = $log->id;
			$time 	  = strftime( "%T", $log->timestamp );
			$address  = $log->address;
			$location = $log->location;
			$scope    = $log->scope;
			$variable = $log->variable;
			$alarm	  = $log->message;
			
			?>
			<tr style='<?=$i++ % 2 != 0 ? "background-color: #EEE;" : "";?>'>
				<td style='padding:1px;' align='center'><?=$time;?></td>
				<td style='padding:1px;' align='center'><?=$location != "unknown" && $location != "rd" ? "<img src='http://whois.domaintools.com/images/flags/$location.gif'/>" : "???";?></td>
				<td style='padding:1px;' align='center'><a href='http://whois.domaintools.com/<?=$address;?>' target='_blank'><?=$address;?></a>&nbsp;&nbsp;&nbsp;&nbsp;<a href='<?= get_bloginfo('wpurl'); ?>/wp-content/plugins/wp-sentinel/ipdetails.php?ip=<?= $address; ?>' rel="facebox"><img src='<?= get_bloginfo('wpurl'); ?>/wp-content/plugins/wp-sentinel/view.png' style='border:0px;'/></a></td>
				<td style='padding:1px;' align='center'><b><?=$scope;?></b></td>
				<td style='padding:1px;' align='center'><b><?=$variable;?></b></td>
				<td style='padding:1px;' align='center'><b><?=$alarm;?></b></td>
				<td style='padding:1px;' align='center'><a href='<?= get_bloginfo('wpurl'); ?>/wp-content/plugins/wp-sentinel/details.php?id=<?= $id; ?>' rel="facebox"><img src='<?= get_bloginfo('wpurl'); ?>/wp-content/plugins/wp-sentinel/view.png' style='border:0px;'/></a></td>
				<td style='padding:1px;' align='center'><a href='?page=wp-sentinel&tab=daily&delete=<?=$id;?>'><img src='<?= get_bloginfo('wpurl'); ?>/wp-content/plugins/wp-sentinel/delete.png' style='border:0px;'/></a></td>
			</tr>
			<?			
		}
		
?>
</table>
</td>
</tr>
</table>
<?php
	}
	else{
?>
<br>
<table width="100%" cellpadding="0" cellspacing="1" style="background-color: white; border: 1px dotted gray; padding: 0;">
	<tr><td>No daily activities</td></tr>
</table>
<?php
	}
}

/*
 * Handle the full history report tab. 
 */
function wp_sentinel_handle_full_history(){
	global $wpdb;
		
	/* first of all, do some writability checking */
	$checks = array( 'vectors', 'php/config.php', 'layouts' );
	foreach( $checks as $check ){
		$item = WPS_PATH.$check;
		if( !is_writable($item) ){
			echo "<div style='background-color: white; color: red; font-size: 13px; padding: 10px; border: 1px dotted gray;'><b>'$item'</b> is not writable!!!.</div><br>";
		}
	}
	
	if( isset($_GET['wipe']) ){
		if( $_GET['wipe'] == "daily" ){
			$wpdb->query( $wpdb->prepare( "DELETE FROM ".$wpdb->prefix."wps_logs WHERE timestamp >= %d;", time() - 86400 ) );
		}
		else if( $_GET['wipe'] == "full" ){
			$wpdb->query( $wpdb->prepare( "DELETE FROM ".$wpdb->prefix."wps_logs;" ) );
		}
	}
	else if( isset($_GET['delete']) && is_numeric($_GET['delete']) ){
		$wpdb->query( $wpdb->prepare( "DELETE FROM ".$wpdb->prefix."wps_logs WHERE id = %d;", $_GET['delete'] ) );
	}
	
	if( isset($_GET['pageno']) && is_numeric($_GET['pageno']) ){
   		$pageno = (int)$_GET['pageno'];
	} 
	else {
   		$pageno = 1;
	}
	
	$num_rows = $wpdb->get_var( "SELECT COUNT(id) FROM ".$wpdb->prefix."wps_logs;" );
	$max_rows = 20;
	$lastpage = ceil($num_rows/$max_rows);
	
	if( $pageno > $lastpage || $pageno < 1 ){
		$pageno = 1;
	}
	
	$logs   = $wpdb->get_results( $wpdb->prepare( "SELECT * FROM ".$wpdb->prefix."wps_logs ORDER BY id DESC LIMIT %d,%d;", ($pageno - 1) * $max_rows, $max_rows ) );
	$n_logs = count($logs);
?>
<div style="background-color: white; border: 1px dotted gray; padding: 10px;">
	<b>Download</b> : <a href='<?= get_bloginfo('wpurl'); ?>/wp-content/plugins/wp-sentinel/logdownload.php?action=daily'>daily</a> - <a href='<?= get_bloginfo('wpurl'); ?>/wp-content/plugins/wp-sentinel/logdownload.php?action=full'>full</a>
	<div style="float:right">
	<b>Wipe</b> : <a href='?page=wp-sentinel&tab=daily&wipe=daily'>daily</a> - <a href='?page=wp-sentinel&tab=daily&wipe=full'>full</a>
	</div>
</div>
<?php	
	if( $num_rows ){
?>
<br>
<table width="100%" cellpadding="0" cellspacing="1" style="background-color: white; border: 1px dotted gray; padding: 0;">
	<tr><td>
<b>Logged <?= $num_rows ;?> attack<?= ($num_rows == 1 ? '' : 's') ?>.</b>
<br>
<br>
<table width="100%" cellpadding="0" cellspacing="1" style="background-color: white; border: 1px dotted gray; padding: 0;">
<tr>
	<td style="font-weight: bold; background-color: #CCC; padding:3px;" align='center'>Date</th>
	<td style="font-weight: bold; background-color: #CCC; padding:3px;" align='center'>Time</th>
	<td style="font-weight: bold; background-color: #CCC; padding:3px;" align='center'>Location</th>
	<td style="font-weight: bold; background-color: #CCC; padding:3px;" align='center'>Address</th>
	<td style="font-weight: bold; background-color: #CCC; padding:3px;" align='center'>Scope</th>
	<td style="font-weight: bold; background-color: #CCC; padding:3px;" align='center'>Variable</th>
	<td style="font-weight: bold; background-color: #CCC; padding:3px;" align='center'>Alarm</th>
	<td style="font-weight: bold; background-color: #CCC; padding:3px;" align='center'>Details</th>
	<td style="font-weight: bold; background-color: #CCC; padding:3px;" align='center'>Delete</th>
</tr>
<?php
		$i = 0;
		foreach( $logs as $log ){
			$id		  = $log->id;
			$date     = strftime( "%D", $log->timestamp );
			$time 	  = strftime( "%T", $log->timestamp );
			$address  = $log->address;
			$location = $log->location;
			$scope    = $log->scope;
			$variable = $log->variable;
			$alarm	  = $log->message;
			
			?>
			<tr style='<?=$i++ % 2 != 0 ? "background-color: #EEE;" : "";?>'>
				<td style='padding:1px;' align='center'><?=$date;?></td>
				<td style='padding:1px;' align='center'><?=$time;?></td>
				<td style='padding:1px;' align='center'><?=$location != "unknown" && $location != "rd" ? "<img src='http://whois.domaintools.com/images/flags/$location.gif'/>" : "???";?></td>
				<td style='padding:1px;' align='center'><a href='http://whois.domaintools.com/<?=$address;?>' target='_blank'><?=$address;?></a>&nbsp;&nbsp;&nbsp;&nbsp;<a href='<?= get_bloginfo('wpurl'); ?>/wp-content/plugins/wp-sentinel/ipdetails.php?ip=<?= $address; ?>' rel="facebox"><img src='<?= get_bloginfo('wpurl'); ?>/wp-content/plugins/wp-sentinel/view.png' style='border:0px;'/></a></td>
				<td style='padding:1px;' align='center'><b><?=$scope;?></b></td>
				<td style='padding:1px;' align='center'><b><?=$variable;?></b></td>
				<td style='padding:1px;' align='center'><b><?=$alarm;?></b></td>
				<td style='padding:1px;' align='center'><a href='<?= get_bloginfo('wpurl'); ?>/wp-content/plugins/wp-sentinel/details.php?id=<?= $id; ?>' rel="facebox"><img src='<?= get_bloginfo('wpurl'); ?>/wp-content/plugins/wp-sentinel/view.png' style='border:0px;'/></a></td>
				<td style='padding:1px;' align='center'><a href='?page=wp-sentinel&tab=full&delete=<?=$id;?>'><img src='<?= get_bloginfo('wpurl'); ?>/wp-content/plugins/wp-sentinel/delete.png' style='border:0px;'/></a></td>
			</tr>
			<?			
		}
		
?>
</table>
</td>
</tr>
<tr>
	<td colspan="9" align="center">
	<?php
		if( $pageno == 1 ){
  			echo " <b>&lt;</b> <b>&lt;&lt;</b> ";
		} 
		else{
   			echo " <a href='?page=wp-sentinel&tab=full&pageno=1' style='text-decoration:none;'><b>&lt;&lt;</b></a> ";
   			$prevpage = $pageno - 1;
   			echo " <a href='?page=wp-sentinel&tab=full&pageno=$prevpage' style='text-decoration:none;'><b>&lt;</b></a> ";
		}
		echo " ( Page <b>$pageno</b> of <b>$lastpage</b> ) ";
		if ($pageno == $lastpage) {
   			echo " <b>&gt;</b> <b>&gt;&gt;</b> ";
		} 
		else{
   			$nextpage = $pageno + 1;
   			echo " <a href='?page=wp-sentinel&tab=full&pageno=$nextpage' style='text-decoration:none;'><b>&gt;</b></a> ";
   			echo " <a href='?page=wp-sentinel&tab=full&pageno=$lastpage' style='text-decoration:none;'><b>&gt;&gt;</b></a> ";
		}
	?>
	</td>
</tr>
</table>
<?php
	}
	else{
?>
<br>
<table width="100%" cellpadding="0" cellspacing="1" style="background-color: white; border: 1px dotted gray; padding: 0;">
	<tr><td>No activities</td></tr>
</table>
<?php
	}
}

/*
 * Handle the layout editing tab. 
 */
function wp_sentinel_handle_layouts(){
	if( isset($_POST['update']) ){
		$error = null;
		if( !is_writable(WPS_PATH."layouts/email.row.layout") ){
			$error = "email.row.layout is not writable!";
		}
		else if( !is_writable(WPS_PATH."layouts/email.layout") ){
			$error = "email.layout is not writable!";
		}
		else if( !is_writable(WPS_PATH."layouts/alarm.row.layout") ){
			$error = "alarm.row.layout is not writable!";
		}
		else if( !is_writable(WPS_PATH."layouts/alarm.layout") ){
			$error = "alarm.layout is not writable!";
		}
		
		foreach( $_POST as $key => $value ){
			$_POST[$key] = html_entity_decode($value);
			if( function_exists('get_magic_quotes_gpc') && get_magic_quotes_gpc() ){
				$_POST[$key] = stripslashes($_POST[$key]);
			}		
			$_POST[$key] = urldecode($_POST[$key]);
		}
		
		if( !file_put_contents( WPS_PATH."layouts/email.row.layout", $_POST['email_row_layout'] ) ){
			$error = "Error during file update.";
		}
		else if( !file_put_contents( WPS_PATH."layouts/email.layout", $_POST['email_layout'] ) ){
			$error = "Error during file update.";
		}
		else if( !file_put_contents( WPS_PATH."layouts/alarm.row.layout", $_POST['alarm_row_layout'] ) ){
			$error = "Error during file update.";
		}
		else if( !file_put_contents( WPS_PATH."layouts/alarm.layout", $_POST['alarm_layout'] ) ){
			$error = "Error during file update.";
		}
		
		if( $error != null ){
			echo "<div style='background-color: white; color: red; font-size: 13px; padding: 10px; border: 1px dotted gray;'>$error</div><br>";
		}
		else{
			echo "<div style='background-color: white; color: green; font-size: 13px; padding: 10px; border: 1px dotted gray;'>Succesfully updated.</div><br>";
		}
	}
	
	$email_row_layout = @file_get_contents_utf8(WPS_PATH."layouts/email.row.layout");
	$email_layout     = @file_get_contents_utf8(WPS_PATH."layouts/email.layout");
	$alarm_row_layout = @file_get_contents_utf8(WPS_PATH."layouts/alarm.row.layout");
	$alarm_layout     = @file_get_contents_utf8(WPS_PATH."layouts/alarm.layout");
?>
<form method="POST">
<table width="100%" cellpadding="0" cellspacing="1" style="background-color: white; border: 1px dotted gray; padding: 0;">
	<tr><td><b>Single alarm layout for email notification</b> <em>(content of {ALARM_ROWS} in email layout)</em></td></tr>
	<tr>
	<td>
		Allowed tokens:
		<table cellpadding="0" cellspacing="5">
			<tr>
				<td style="padding: 0px;"><b>{SCOPE}</b></td>
				<td style="padding: 0px;">GET or POST of the variable.</td>
			</tr>
			<tr>
				<td style="padding: 0px;"><b>{VARIABLE}</b></td>
				<td style="padding: 0px;">The variable name.</td>
			</tr>
			<tr>
				<td style="padding: 0px;"><b>{CONTENT}</b></td>
				<td style="padding: 0px;">The variable content.</td>
			</tr>
			<tr>
				<td style="padding: 0px;"><b>{ALARM}</b></td>
				<td style="padding: 0px;">Name of the alarm that was triggered by the request.</td>
			</tr>
			<tr>
				<td style="padding: 0px;"><b>{RULE}</b></td>
				<td style="padding: 0px;">Regex that matched the alarm.</td>
			</tr>
		</table>
	</td>
	</tr>
	<tr>
	<td>
		<textarea name="email_row_layout" cols=100 rows=3><?= htmlentities($email_row_layout); ?></textarea>	
	</td>
	</tr>
	
	<tr><td><b>EMail layout</b></td></tr>
	<tr>
	<td>
		Allowed tokens:
		<table cellpadding="0" cellspacing="5">
			<tr>
				<td style="padding: 0px;"><b>{DATE}</b></td>
				<td style="padding: 0px;">Date of the attack.</td>
			</tr>
			<tr>
				<td style="padding: 0px;"><b>{ADDRESS}</b></td>
				<td style="padding: 0px;">IP address of the attacker.</td>
			</tr>
			<tr>
				<td style="padding: 0px;"><b>{USERNAME}</b></td>
				<td style="padding: 0px;">Wordpress username of the attacker if he's logged.</td>
			</tr>
			<tr>
				<td style="padding: 0px;"><b>{REFERER}</b></td>
				<td style="padding: 0px;">HTTP referer.</td>
			</tr>
			<tr>
				<td style="padding: 0px;"><b>{USERAGENT}</b></td>
				<td style="padding: 0px;">HTTP user-agent.</td>
			</tr>
			<tr>
				<td style="padding: 0px;"><b>{ALARM_ROWS}</b></td>
				<td style="padding: 0px;">Content of the single alarm layouts filled with alarm data.</td>
			</tr>
		</table>
	</td>
	</tr>

	<tr>
	<td>
		<textarea name="email_layout" cols=100 rows=10><?= htmlentities($email_layout); ?></textarea>	
	</td>
	</tr>
	
	<tr><td><b>Single alarm layout for user notification</b> <em>(content of {ALARM_ROWS} in alarm layout)</em></td></tr>
	<tr>
	<td>
		Allowed tokens:
		<table cellpadding="0" cellspacing="5">
			<tr>
				<td style="padding: 0px;"><b>{SCOPE}</b></td>
				<td style="padding: 0px;">GET or POST of the variable.</td>
			</tr>
			<tr>
				<td style="padding: 0px;"><b>{VARIABLE}</b></td>
				<td style="padding: 0px;">The variable name.</td>
			</tr>
			<tr>
				<td style="padding: 0px;"><b>{CONTENT}</b></td>
				<td style="padding: 0px;">The variable content.</td>
			</tr>
			<tr>
				<td style="padding: 0px;"><b>{ALARM}</b></td>
				<td style="padding: 0px;">Name of the alarm that was triggered by the request.</td>
			</tr>
			<tr>
				<td style="padding: 0px;"><b>{RULE}</b></td>
				<td style="padding: 0px;">Regex that matched the alarm.</td>
			</tr>
		</table>
	</td>
	</tr>
	<tr>
	<td>
		<textarea name="alarm_row_layout" cols=100 rows=8><?= htmlentities($alarm_row_layout); ?></textarea>	
	</td>
	</tr>
	
	<tr><td><b>Alarm layout</b></td></tr>
	<tr>
	<td>
		Allowed tokens:
		<table cellpadding="0" cellspacing="5">
			<tr>
				<td style="padding: 0px;"><b>{ALARM_ROWS}</b></td>
				<td style="padding: 0px;">Content of the single alarm layouts filled with alarm data.</td>
			</tr>
		</table>
	</td>
	</tr>
	<tr>
	<td>
		<textarea name="alarm_layout" cols=100 rows=20><?= htmlentities($alarm_layout); ?></textarea>	
	</td>
	</tr>
	
	<tr>
		<td><input class="button-primary" type="submit" value="Update" name="update"/></td> 
	</tr>
</table>
</form>
<?php	
}

/*
 * Handle the settings tab. 
 */
function wp_sentinel_handle_settings(){
	global $wps_config;
	
	$config_path = WPS_PATH."php/config.php";

	if( isset($_POST['update']) ){
		$error = null;
		if( !is_writable($config_path) ){
			$error = "Configuration file '$config_path' is not writable!";
		}
		
		$tmp 	   = explode( ',', $_POST['whitelist'] );
		$whitelist = array();
		foreach( $tmp as $item ){
			$item = trim($item);
			if( $item != '' ){
				$whitelist[] = "'".trim($item)."'";
			}
		}
		
		$tmp 	      = explode( ',', $_POST['allowed_html'] );
		$allowed_html = array();
		foreach( $tmp as $item ){
			$item = trim($item);
			if( $item != '' ){
				$allowed_html[] = "'".trim($item)."'";
			}
		}
		
		$data =
'<?php

$wps_config = array( 
	/* enable or disable wp-sentinel filtering */
	"enabled"      => '.($_POST['enabled'] == 1 ? 1 : 0).',
	/* enable or disable email notifications to the blog administrator */
	"notification" => '.($_POST['notification'] == 1 ? 1 : 0).',
	/* enable or disable logging */
	"logging"      => '.($_POST['logging'] == 1 ? 1 : 0).',
	/* flood delay time in seconds */
	"flood_time"   => '.(INT)$_POST['flood_time'].',
	/* variables to be ignored */
	"whitelist"    => array( '.(implode( ', ', $whitelist )).' ),
	/* allowed HTML tags */
	"allowed_html" => array( '.(implode( ', ', $allowed_html )).' ),
	/* max login attempts before getting blocked */
	"max_logins"   => '.(INT)$_POST['max_logins'].'
);
	
?>';	
		
		if( !file_put_contents( $config_path, $data ) ){
			$error = "Error during file update.";
		}
		else{
			include( $config_path );
		}
		
		if( $error != null ){
			echo "<div style='background-color: white; color: red; font-size: 13px; padding: 10px; border: 1px dotted gray;'>$error</div><br>";
		}
		else{
			echo "<div style='background-color: white; color: green; font-size: 13px; padding: 10px; border: 1px dotted gray;'>Succesfully updated.</div><br>";
		}
	}
?>
<form method="POST">
<table width="100%" cellpadding="0" cellspacing="1" style="background-color: white; border: 1px dotted gray; padding: 0;">

<tr>
<td><b>Sentinel Status</b></td> 
<td>
	<input type='radio' name='enabled' <?=($wps_config['enabled'] == 1 ? 'checked' : '');?> value="1"> <font color='green'>Enabled</font>&nbsp;&nbsp;&nbsp;&nbsp;
	<input type='radio' name='enabled' <?=($wps_config['enabled'] != 1 ? 'checked' : '');?> value="0"> <font color='red'>Disabled</font>
</td>
</tr>
<tr>
<td colspan="2" valign="top" style="padding-top: 0px; border-bottom: 1px dotted gray;"><em>Enable or disable the plugin, use carefully!</em></td>
</tr>

<tr>
<td><b>EMail Notifications</b></td> 
<td>
	<input type='radio' name='notification' <?=($wps_config['notification'] == 1 ? 'checked' : '');?> value="1"> Enabled&nbsp;&nbsp;&nbsp;&nbsp;
	<input type='radio' name='notification' <?=($wps_config['notification'] != 1 ? 'checked' : '');?> value="0"> Disabled
</td>
</tr>
<tr>
<td colspan="2" valign="top" style="padding-top: 0px; border-bottom: 1px dotted gray;"><em>Enable or disable email notifications to the administrator.</em></td>
</tr>

<tr>
<td><b>File Logging</b></td> 
<td>
	<input type='radio' name='logging' <?=($wps_config['logging'] == 1 ? 'checked' : '');?> value="1"> <font color='green'>Enabled</font>&nbsp;&nbsp;&nbsp;&nbsp;
	<input type='radio' name='logging' <?=($wps_config['logging'] != 1 ? 'checked' : '');?> value="0"> <font color='red'>Disabled</font>
</td>
</tr>
<tr>
<td colspan="2" valign="top" style="padding-top: 0px; border-bottom: 1px dotted gray;"><em>Enable or disable file logging during an attack.</em></td>
</tr>

<tr>
<td><b>Flood Delay</b></td> 
<td>
	<input type="text" name="flood_time" value="<?= $wps_config['flood_time']; ?>"/>
</td>
</tr>
<tr>
<td colspan="2" valign="top" style="padding-top: 0px; border-bottom: 1px dotted gray;"><em>Delay, in seconds, below which attacks will be considered as flooding and will not be logged, this delay is used as anti bruteforcing delay too.</em></td>
</tr>

<tr>
<td><b>Whitelisted Variables</b></td> 
<td>
	<input type="text" name="whitelist" value="<?= implode( ', ', $wps_config['whitelist'] ); ?>" size="200"/>
</td>
</tr>
<tr>
<td colspan="2" valign="top" style="padding-top: 0px; border-bottom: 1px dotted gray;"><em>Those comma separated variables are not going to be checked by WP-Sentinel.</em></td>
</tr>

<tr>
<td><b>Allowed HTML Tags</b></td> 
<td>
	<input type="text" name="allowed_html" value="<?= implode( ', ', $wps_config['allowed_html'] ); ?>" size="200"/>
</td>
</tr>
<tr>
<td colspan="2" valign="top" style="padding-top: 0px; border-bottom: 1px dotted gray;"><em>A list of comma separated HTML tags that users are allowed to use inside comments ecc.</em></td>
</tr>

<tr>
<td><b>Max Login Attempts</b></td> 
<td>
	<input type="text" name="max_logins" value="<?= $wps_config['max_logins']; ?>" />
</td>
</tr>
<tr>
<td colspan="2" valign="top" style="padding-top: 0px;"><em>Number of maximum login attempts after the wich the user will be unable to login for 'flood delay' seconds.</em></td>
</tr>

<tr>
<td><input class="button-primary" type="submit" value="Update" name="update"/></td> 
<td>
</td>
</tr>

</table>
</form>
<?php
}

function wp_sentinel_menu() {
	add_options_page( 'WP-Sentinel Options', 'WP-Sentinel', 'manage_options', 'wp-sentinel', 'wp_sentinel_options' );
}

function wp_sentinel_options() {
	if( !current_user_can('manage_options') ){
    	wp_die( __('You do not have sufficient permissions to access this page.') );
  	}

?>
<div class="wrap">
<h2>WP-Sentinel Security System <div style="font-size: 12px; font-weight: normal; display: inline;">ver <?= WPS_VERS ?></div></h2>
<?php wp_sentinel_generate_tabs(); ?>
<table class="form-table">
<tr>
<td>
<?php
$tab = isset($_GET['tab']) ? $_GET['tab'] : 'daily';
switch($tab){
	case 'full'     : wp_sentinel_handle_full_history(); break;
	case 'settings' : wp_sentinel_handle_settings(); break;
	case 'layouts'  : wp_sentinel_handle_layouts();  break;

	default 		: wp_sentinel_handle_daily();
}
?>
</td>
</tr>
</table>
</div>
<?
}


?>